// About.java
/* A Java class for
 * LineImpedance.java
 * Electromagnetic Transmission Line Applet
 * Applet without Smith Chart - Prepared by Umberto Ravaioli 
 * for 6th edition of Fundamentals of Applied Electromagnetics Book
 * May 2009 - All Rights Reserved
 */   


import java.io.*;
import java.applet.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.font.*;
import java.net.URL;
import java.text.*;
import java.util.*;
import java.util.Map;
import java.util.Hashtable;
import java.util.jar.Attributes;


public class Instructions extends Panel {
    
    private static final Color bgcolor = new Color(255,255,245);
    //private static final Color bgcolor = Color.white;
    
    public TextField epsilon;
    private Paint paint;
    
    private Image im;
    private Graphics buf;

    //Mod1State state;
    public Button closeIt;
  
    public Instructions(){
	super();
        //this.state = state;
	setLayout(null);
	setBackground(bgcolor);
	closeIt = new Button("CLOSE");
        closeIt.setBackground(new Color(240,240,255));
	add(closeIt);
        //int buttonx = 380;
        //int buttony = 380;
        int buttonx = 430;
        int buttony = 550;
        int buttonwide = 70;
        int buttonheight = 27;
        
        closeIt.setBounds(buttonx,buttony,buttonwide,buttonheight);	
        Panel ps7 = new Panel();
	    ps7.setBackground(Color.lightGray);
	    add(ps7);
	    ps7.setBounds(buttonx-1,buttony-1,buttonwide+2,buttonheight+2);
	    
	Panel ps8 = new Panel();
	    ps8.setBackground(Color.black);
	    add(ps8);
	    ps8.setBounds(buttonx-2,buttony-2,buttonwide+4,buttonheight+4);	
    }
    
    public void paint(Graphics g){
            
	    if(im == null){
		im = createImage(getSize().width,getSize().height);
		buf = im.getGraphics();
		drawCanvas(buf);
	    }
	    else{
		drawCanvas(buf);
	    }
	    g.drawImage(im,0,0,null);
    }
	
	//Addition to reduce flicker new routine
    public void update(Graphics g){		// added to avoid clearing
            paint(g);
    }
    
    public void clear(){
	    this.getGraphics().clearRect(0,0,getSize().width,getSize().height);
	    repaint();
    }
    
    public void drawCanvas(Graphics g){
        FontMetrics fm;
        Graphics2D g2d = (Graphics2D)g;
        g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                             RenderingHints.VALUE_ANTIALIAS_ON);        
        g.clearRect(0,0,getSize().width-1,getSize().height-1);

        //g.setFont(font_one);
        //fm = g.getFontMetrics();

        //boolean saveOldFlag = MaestroG.useBiggerFont;
        //MaestroG.useBiggerFont = false;
        
        g.setColor(Color.black);
        //g.setFont(state.ttfFont.deriveFont(Font.BOLD,16f));
        g.setFont(new Font("SanSerif",Font.BOLD,16));

        g.drawString("Instructions", 15,25);
        g.setColor(Color.red);
        //g.setFont(state.ttfFont.deriveFont(Font.BOLD,15f));
        g.setFont(new Font("SanSerif",Font.BOLD,15));

        g.drawString("Input", 15,50);
        //g.drawString("Output", 230,50);
        g.setColor(Color.black);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        int deltaY = 20;
        
        //INPUT
        String s = "\u2022 Select the initial location of the electron "+
            "(x"+STR.SUB+"0"+STR.ENDSUB+",y"+STR.SUB+"0"+STR.ENDSUB+")";
        int nextX = STR.displayString(s,g, 15,70);
        s = "\u2022 Select the initial velocity of the electron "+STR.VBAR+
            "u"+STR.ENDVBAR+" = "+STR.HAT+"x"+STR.ENDHAT+"u"+STR.SUB+"x"+
            STR.ENDSUB+STR.SUBSUB+"0"+STR.ENDSUBSUB+"+"+STR.HAT+"y"+
            STR.ENDHAT+"u"+STR.SUB+"y"+STR.ENDSUB+STR.SUBSUB+"0"+STR.ENDSUBSUB;
        nextX = STR.displayString(s,g, 15,70+deltaY);
        s = "\u2022 Select the electric field "+STR.VBAR+"E"+STR.ENDVBAR+
            " = "+STR.HAT+"x"+STR.ENDHAT+"E"+STR.SUB+"x"+STR.ENDSUB+"+"+
            STR.HAT+"y"+STR.ENDHAT+"E"+STR.SUB+"y"+STR.ENDSUB;
        nextX = STR.displayString(s,g, 15,70+2*deltaY);
        s = "\u2022 Select the magnetic field "+STR.VBAR+"H"+STR.ENDVBAR+
            " = "+STR.HAT+"z"+STR.ENDHAT+"H"+STR.SUB+"z"+STR.ENDSUB;
        nextX = STR.displayString(s,g, 15,70+3*deltaY);

        g.drawString("\u2022 Select the time step between updates",
                     15,70+4*deltaY);
       //OUTPUT
        g.setColor(Color.red);
        //g.setFont(state.ttfFont.deriveFont(Font.BOLD,15f));
        g.setFont(new Font("SanSerif",Font.BOLD,15));

        int newY = 70+6*deltaY+40;
        g.drawString("Displayed Information", 15,newY);
        g.setColor(Color.black);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        newY += 20;
        s = "\u2022 Select to observe either:";
        nextX = STR.displayString(s,g, 15,newY);
        s = "   (a) the electron motion in the x-y plane with the electric "+
            "and magnetic";
        nextX = STR.displayString(s,g,15,newY+deltaY);
        s = "       forces acting on it displayed as red and blue arrows, "+
            "respectively, or";
        nextX = STR.displayString(s,g,15,newY+2*deltaY);
        s = "   (b) the trace generated by the moving electron";
        nextX = STR.displayString(s,g,15,newY+3*deltaY);

        s = "\u2022 Select to place the electron inside a closed boundary "+
            "or in an open";
        nextX = STR.displayString(s,g,15,newY+5*deltaY);
        s = "   boundary";
        nextX = STR.displayString(s,g,15,newY+6*deltaY);

        drawCopyRight(g);

        //MaestroG.useBiggerFont = saveOldFlag;

    }




    public void drawCopyRight(Graphics g) {
        int deltaY = 20;
        int startingY = getSize().height - 70;
        int startingX = 0;
        int DeltaX = 10;
        FontMetrics fm;
        g.setColor(Color.black);
        g.setColor(Color.black);
        //g.setFont(normalfont14);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        fm = g.getFontMetrics();
        g.drawString("Applet Design: Umberto Ravaioli",
                     startingX+DeltaX,startingY+deltaY);
        
        //MaestroG.superscripter("Interactive Java","TM"," platform:  www.amanogawa.com",
        //                       g,14,startingX,startingY+2*deltaY);
        String s = "Interactive Java"+STR.SUP+"TM"+STR.ENDSUP+
            " platform:  www.amanogawa.com";
        int nextX = STR.displayString(s,g,startingX+DeltaX,startingY+2*deltaY);
        int lineLength = fm.stringWidth("Interactive JavaTM platform:  www.amanogawa.com");
        lineLength+= 10;

        //g.setFont(state.ttfFont.deriveFont(14f));
        g.drawString("All Rights Reserved",startingX+DeltaX,startingY+3*deltaY);
        g.drawLine(startingX,startingY+5,
                   startingX+lineLength+10,startingY+5);
        g.drawLine(startingX+lineLength+10,startingY+5,
                   startingX+lineLength+10,startingY+4*deltaY);
    }



    public void OLDdrawCopyRight(Graphics g) {
        int deltaY = 20;
        int startingY = getSize().height - 60;
        int startingX = 0;
        FontMetrics fm;
        g.setColor(Color.black);
        g.setColor(Color.black);
        //g.setFont(normalfont14);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        fm = g.getFontMetrics();

        startingY += deltaY;
        g.drawString("Applet Design: Eric Michielssen and Janice Richards",
                     startingX,startingY+deltaY);
        
        //MaestroG.superscripter("Interactive Java","TM"," platform:  www.amanogawa.com",
        //                       g,14,startingX,startingY+2*deltaY);
        //String s = "Interactive Java"+STR.SUP+"TM"+STR.ENDSUP+
        //    " platform:  www.amanogawa.com";
        //int nextX = STR.displayString(s,g,startingX,startingY+2*deltaY);
        //int lineLength = fm.stringWidth("Interactive JavaTM platform:  www.amanogawa.com");
        //lineLength+= 10;

        int lineLength = fm.stringWidth("Applet Design: Eric Michielssen and Janice Richards");
        lineLength+= 10;

        //g.setFont(state.ttfFont.deriveFont(14f));
        //g.drawString("All Rights Reserved",startingX,startingY+3*deltaY-5);
        g.drawLine(startingX,startingY+5,
                   startingX+lineLength+10,startingY+5);
        //g.drawLine(startingX+lineLength+10,startingY+5,
        //           startingX+lineLength+10,startingY+4*deltaY);
        g.drawLine(startingX+lineLength+10,startingY+5,
                   startingX+lineLength+10,startingY+2*deltaY);
    }

//----------------------------------------------------------------------------------------    
}//End
    

